/*
See LICENSE folder for this sample’s licensing information.

Abstract:
The application delegate.
*/

import UIKit
import WeatherFramework

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?

    /// - Tag: ParseIncomingURL
    func application(_ app: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey: Any] = [:]) -> Bool {
        guard let navigationController = window?.rootViewController as? UINavigationController,
            let initialViewController = navigationController.viewControllers.first as? ForecastViewController
            else { preconditionFailure("Expected the root view controller to be a UINavigationController") }

        // Extract the daysFromNow query string parameter from the incoming URL.
        let components = URLComponents(url: url, resolvingAgainstBaseURL: false)
        guard let daysFromNowQueryItem = components?.queryItems?.first(where: { queryItem -> Bool in
            return queryItem.name == "daysFromNow"
        }) else { preconditionFailure("Expected a daysFromNow parameter") }
        guard let daysFromNowValue = daysFromNowQueryItem.value
            else { preconditionFailure("Expected daysFromNow parameter to have a value") }
        guard let daysFromNow = Int(daysFromNowValue)
            else { preconditionFailure("Expected daysFromNow to be an integer") }

        // Scroll the initial view controller to the correct index.
        initialViewController.scrollToForecast(index: daysFromNow)

        return true
    }

}
